diff --git a/web/pgadmin/static/js/sqleditor_utils.js b/web/pgadmin/static/js/sqleditor_utils.js
index 663745c9f..fa63a9ab2 100644
--- a/web/pgadmin/static/js/sqleditor_utils.js
+++ b/web/pgadmin/static/js/sqleditor_utils.js
@@ -8,251 +8,15 @@
 //////////////////////////////////////////////////////////////////////////
 // This file contains common utilities functions used in sqleditor modules
 
-define(['jquery', 'underscore', 'sources/gettext', 'sources/url_for', 'pgadmin.alertifyjs'],
-  function ($, _, gettext, url_for, alertify) {
-    var sqlEditorUtils = {
-      /* Reference link http://stackoverflow.com/questions/105034/create-guid-uuid-in-javascript
-       * Modified as per requirement.
-       */
-      epicRandomString: function(length) {
-        var s = [];
-        var hexDigits = '0123456789abcdef';
-        for (var i = 0; i < 36; i++) {
-          s[i] = hexDigits.substr(
-            Math.floor(Math.random() * 0x10), 1
-          );
-        }
-        // bits 12-15 of the time_hi_and_version field to 0010
-        s[14] = '4';
-        // bits 6-7 of the clock_seq_hi_and_reserved to 01
-        s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1);
-        s[8] = s[13] = s[18] = s[23] = '-';
-
-        var uuid = s.join('');
-        return uuid.replace(/-/g, '').substr(0, length);
-      },
-
-      // Returns a unique hash for input string
-      getHash: function(input) {
-        var hash = 0, len = input.length;
-        for (var i = 0; i < len; i++) {
-          hash  = ((hash << 5) - hash) + input.charCodeAt(i);
-          hash |= 0; // to 32bit integer
-        }
-        return hash;
-      },
-      calculateColumnWidth: function (text) {
-        // Calculate column header width based on column name or type
-        // Create a temporary element with given label, append to body
-        // calculate its width and remove the element.
-        $('body').append(
-          '<span id="pg_text" style="visibility: hidden;">'+ text + '</span>'
-        );
-        var width = $('#pg_text').width() + 23;
-        $('#pg_text').remove(); // remove element
-
-        return width;
-      },
-      capitalizeFirstLetter: function (string) {
-        return string.charAt(0).toUpperCase() + string.slice(1);
-      },
-
-      // Disables arrow to change connection
-      disable_connection_dropdown: function (status) {
-        if (status){
-          $('.conn-info-dd').prop('disabled',true);
-          $('.connection-data').css({pointerEvents: 'none', cursor: 'arrow'});
-        }else{
-          $('.conn-info-dd').prop('disabled',false);
-          $('.connection-data').css({pointerEvents: 'auto', cursor: 'pointer'});
-        }
-      },
-
-      // Status flag
-      previousStatus: null,
-
-      // This function will fetch the connection status via ajax
-      fetchConnectionStatus: function(target, $el, $status_el) {
-        // If user has switch the browser Tab or Minimized window or
-        // if wcDocker panel is not in focus then don't fire AJAX
-        var url = url_for('sqleditor.connection_status', {
-          'trans_id': target.transId,
-        });
-
-        if (document.visibilityState !== 'visible' ||
-              $el.data('panel-visible') !== 'visible' ) {
-          return;
-        }
-
-        if($status_el.hasClass('obtaining-conn')){
-          return;
-        }
-        let sqleditor_obj = target;
-
-        // Start polling..
-        $.ajax({
-          url: url,
-          method: 'GET',
-        })
-          .done(function (res) {
-            if(res && res.data) {
-              var status = res.data.status,
-                msg = res.data.message,
-                is_status_changed = false;
-
-              // Raise notify messages comes from database server.
-              sqleditor_obj.update_notifications(res.data.notifies);
-
-              // Inject CSS as required
-              switch(status) {
-              // Busy
-              case 1:
-                // if received busy status more than once then only
-                if(status == sqlEditorUtils.previousStatus &&
-                        !$status_el.hasClass('fa-hourglass-half')) {
-                  $status_el.removeClass()
-                    .addClass('fa fa-hourglass-half');
-                  is_status_changed = true;
-                }
-                break;
-                // Idle in transaction
-              case 2:
-                if(sqlEditorUtils.previousStatus != status &&
-                        !$status_el.hasClass('fa-clock')) {
-                  $status_el.removeClass()
-                    .addClass('fa fa-clock');
-                  is_status_changed = true;
-                }
-                break;
-                // Failed in transaction
-              case 3:
-                if(sqlEditorUtils.previousStatus != status &&
-                        !$status_el.hasClass('fa-exclamation-circle')) {
-                  $status_el.removeClass()
-                    .addClass('fa fa-exclamation-circle');
-                  is_status_changed = true;
-                }
-                break;
-                // Failed in transaction with unknown server side error
-              case 4:
-                if(sqlEditorUtils.previousStatus != status &&
-                        !$status_el.hasClass('fa-exclamation-triangle')) {
-                  $status_el.removeClass()
-                    .addClass('fa fa-exclamation-triangle');
-                  is_status_changed = true;
-                }
-                break;
-              default:
-                if(sqlEditorUtils.previousStatus != status &&
-                        !$status_el.hasClass('fa-query_tool_connected')) {
-                  $status_el.removeClass()
-                    .addClass('pg-font-icon icon-connected');
-                  is_status_changed = true;
-                }
-              }
-
-              sqlEditorUtils.previousStatus = status;
-              // Set bootstrap popover message
-              if(is_status_changed) {
-                $el.popover('hide');
-                $el.attr('data-content', msg);
-              }
-            } else {
-            // We come here means we did not receive expected response
-            // from server, we need to error out
-              sqlEditorUtils.previousStatus = -99;
-              msg = gettext('An unexpected error occurred - ' +
-                          'ensure you are logged into the application.');
-              $el.attr('data-content', msg);
-              if(!$status_el.hasClass('icon-disconnected')) {
-                $el.popover('hide');
-                $status_el.removeClass()
-                  .addClass('pg-icon-font icon-disconnected');
-              }
-            }
-          })
-          .fail(function (e) {
-            sqlEditorUtils.previousStatus = -1;
-            var msg = gettext('Transaction status check failed.');
-            if (e.readyState == 0) {
-              msg = gettext('Not connected to the server or the connection to ' +
-                          'the server has been closed.');
-            } else if (e.responseJSON && e.responseJSON.errormsg) {
-              msg = e.responseJSON.errormsg;
-            }
-
-            // Set bootstrap popover
-            $el.attr('data-content', msg);
-            // Add error class
-            if(!$status_el.hasClass('icon-disconnected')) {
-              $el.popover('hide');
-              $status_el.removeClass()
-                .addClass('pg-font-icon icon-disconnected');
-            }
-          });
-      },
-
-      // Updates the flag for connection status poll
-      updateConnectionStatusFlag: function(status) {
-        var $el = $('.connection_status');
-        if ($el.data('panel-visible') != status) {
-          $el.data('panel-visible', status);
-        }
-      },
-
-      calcFontSize: function(fontSize) {
-        if(fontSize) {
-          fontSize = parseFloat((Math.round(parseFloat(fontSize + 'e+2')) + 'e-2'));
-          let rounded = Number(fontSize);
-          if(rounded > 0) {
-            return rounded + 'em';
-          }
-        }
-        return '1em';
-      },
-
-      addEditableIcon: function(columnDefinition, is_editable) {
-        /* This uses Slickgrid.HeaderButtons plugin to add an icon to the
-        columns headers. Instead of a button, an icon is created */
-        let content = null;
-        if(is_editable) {
-          content = '<i class="fa fa-pencil-alt"></i>';
-        }
-        else {
-          content = '<i class="fa fa-lock"></i>';
-        }
-        let button = {
-          cssClass: 'editable-column-header-icon',
-          content: content,
-        };
-        // Check for existing buttons
-        if(!_.isUndefined(columnDefinition.header) &&
-           !_.isUndefined(columnDefinition.header.buttons)) {
-          columnDefinition.header.buttons.push(button);
-        }
-        else {
-          columnDefinition.header = {
-            buttons: [button],
-          };
-        }
-      },
-
-      isModalOpen: function(dialog_list) {
-        /* check the modals inside the sqleditor are open or not */
-        if(Array.isArray(dialog_list)) {
-          for(let d of dialog_list) {
-            try {
-              if(alertify.dialog(d) && alertify.dialog(d).isOpen())
-                return true;
-            }
-            catch (err) {
-              // Do nothing
-              console.warn(err.stack || err);
-            }
-          }
-        }
-        return false;
-      },
-    };
-    return sqlEditorUtils;
-  });
+module.exports = {
+  calcFontSize: function(fontSize) {
+    if(fontSize) {
+      fontSize = parseFloat((Math.round(parseFloat(fontSize + 'e+2')) + 'e-2'));
+      let rounded = Number(fontSize);
+      if(rounded > 0) {
+        return rounded + 'em';
+      }
+    }
+    return '1em';
+  },
+};
diff --git a/web/pgadmin/static/js/utils.js b/web/pgadmin/static/js/utils.js
index 9d6716533..2221997a2 100644
--- a/web/pgadmin/static/js/utils.js
+++ b/web/pgadmin/static/js/utils.js
@@ -302,7 +302,7 @@ export function sprintf(i_str) {
 
 // Modified ref: http://stackoverflow.com/a/1293163/2343 to suite pgAdmin.
 // This will parse a delimited string into an array of arrays.
-export function CSVToArray( strData, strDelimiter, quoteChar){
+export function CSVToArray(strData, strDelimiter, quoteChar){
   strDelimiter = strDelimiter || ',';
   quoteChar = quoteChar || '"';
 
@@ -323,6 +323,12 @@ export function CSVToArray( strData, strDelimiter, quoteChar){
   // a default empty first row.
   var arrData = [[]];
 
+  // The regex doesn't handle and skips start value if
+  // string starts with delimiter
+  if(strData.startsWith(strDelimiter)) {
+    arrData[ arrData.length - 1 ].push(null);
+  }
+
   // Create an array to hold our individual pattern
   // matching groups.
   var arrMatches = null;
diff --git a/web/pgadmin/tools/debugger/static/js/debugger.js b/web/pgadmin/tools/debugger/static/js/debugger.js
index 44cd53c47..0ac8293c3 100644
--- a/web/pgadmin/tools/debugger/static/js/debugger.js
+++ b/web/pgadmin/tools/debugger/static/js/debugger.js
@@ -14,8 +14,8 @@ define([
   'alertify', 'sources/pgadmin', 'pgadmin.browser',
   'backbone', 'pgadmin.backgrid', 'codemirror', 'pgadmin.backform',
   'pgadmin.tools.debugger.ui', 'pgadmin.tools.debugger.utils',
-  'tools/datagrid/static/js/show_query_tool', 'sources/utils',
-  'pgadmin.authenticate.kerberos', 'tools/datagrid/static/js/datagrid_panel_title',
+  'tools/sqleditor/static/js/show_query_tool', 'sources/utils',
+  'pgadmin.authenticate.kerberos', 'tools/sqleditor/static/js/sqleditor_title',
   'wcdocker', 'pgadmin.browser.frame',
 ], function(
   gettext, url_for, $, _, Alertify, pgAdmin, pgBrowser, Backbone, Backgrid,
diff --git a/web/pgadmin/tools/debugger/static/js/debugger_utils.js b/web/pgadmin/tools/debugger/static/js/debugger_utils.js
index 8352ae895..fbc2f4b7c 100644
--- a/web/pgadmin/tools/debugger/static/js/debugger_utils.js
+++ b/web/pgadmin/tools/debugger/static/js/debugger_utils.js
@@ -6,8 +6,8 @@
 // This software is released under the PostgreSQL Licence
 //
 //////////////////////////////////////////////////////////////////////////
-import {generateTitle} from '../../../datagrid/static/js/datagrid_panel_title';
-import {_set_dynamic_tab} from '../../../datagrid/static/js/show_query_tool';
+import {generateTitle} from '../../../sqleditor/static/js/sqleditor_title';
+import {_set_dynamic_tab} from '../../../sqleditor/static/js/show_query_tool';
 
 function setFocusToDebuggerEditor(editor, command) {
   const TAB = 9;
diff --git a/web/pgadmin/tools/erd/static/js/erd_module.js b/web/pgadmin/tools/erd/static/js/erd_module.js
index b418885e3..9a0e7309b 100644
--- a/web/pgadmin/tools/erd/static/js/erd_module.js
+++ b/web/pgadmin/tools/erd/static/js/erd_module.js
@@ -7,7 +7,7 @@
 //
 //////////////////////////////////////////////////////////////
 
-import {getPanelTitle} from 'tools/datagrid/static/js/datagrid_panel_title';
+import {getPanelTitle} from 'tools/sqleditor/static/js/sqleditor_title';
 import {getRandomInt, registerDetachEvent} from 'sources/utils';
 import Notify from '../../../../static/js/helpers/Notifier';
 
diff --git a/web/pgadmin/tools/erd/static/js/erd_tool/ui_components/BodyWidget.jsx b/web/pgadmin/tools/erd/static/js/erd_tool/ui_components/BodyWidget.jsx
index 2b598d808..0eb34fc77 100644
--- a/web/pgadmin/tools/erd/static/js/erd_tool/ui_components/BodyWidget.jsx
+++ b/web/pgadmin/tools/erd/static/js/erd_tool/ui_components/BodyWidget.jsx
@@ -22,7 +22,7 @@ import FloatingNote from './FloatingNote';
 import {setPanelTitle} from '../../erd_module';
 import gettext from 'sources/gettext';
 import url_for from 'sources/url_for';
-import {showERDSqlTool} from 'tools/datagrid/static/js/show_query_tool';
+import {showERDSqlTool} from 'tools/sqleditor/static/js/show_query_tool';
 import 'wcdocker';
 import Theme from '../../../../../../static/js/Theme';
 import TableSchema from '../../../../../../browser/server_groups/servers/databases/schemas/tables/static/js/table.ui';
@@ -579,7 +579,7 @@ export default class BodyWidget extends React.Component {
 
         let sqlId = `erd${this.props.params.trans_id}`;
         localStorage.setItem(sqlId, sqlScript);
-        showERDSqlTool(parentData, sqlId, this.props.params.title, this.props.pgWindow.pgAdmin.DataGrid, this.props.alertify);
+        showERDSqlTool(parentData, sqlId, this.props.params.title, this.props.pgWindow.pgAdmin.Tools.SQLEditor, this.props.alertify);
       })
       .catch((error)=>{
         this.handleAxiosCatch(error);
diff --git a/web/pgadmin/tools/psql/static/js/psql_module.js b/web/pgadmin/tools/psql/static/js/psql_module.js
index e3380152c..f70f1901a 100644
--- a/web/pgadmin/tools/psql/static/js/psql_module.js
+++ b/web/pgadmin/tools/psql/static/js/psql_module.js
@@ -18,7 +18,7 @@ import {retrieveAncestorOfTypeServer} from 'sources/tree/tree_utils';
 import pgWindow from 'sources/window';
 import Notify from '../../../../static/js/helpers/Notifier';
 
-import {generateTitle, refresh_db_node} from 'tools/datagrid/static/js/datagrid_panel_title';
+import {generateTitle, refresh_db_node} from 'tools/sqleditor/static/js/sqleditor_title';
 
 
 export function setPanelTitle(psqlToolPanel, panelTitle) {
diff --git a/web/pgadmin/tools/schema_diff/static/js/schema_diff_ui.js b/web/pgadmin/tools/schema_diff/static/js/schema_diff_ui.js
index d47c266a4..a8b23d9eb 100644
--- a/web/pgadmin/tools/schema_diff/static/js/schema_diff_ui.js
+++ b/web/pgadmin/tools/schema_diff/static/js/schema_diff_ui.js
@@ -15,8 +15,7 @@ import Backbone from 'backbone';
 import Slick from 'sources/../bundle/slickgrid';
 import pgAdmin from 'sources/pgadmin';
 import {setPGCSRFToken} from 'sources/csrf';
-import {generateScript} from 'tools/datagrid/static/js/show_query_tool';
-import 'pgadmin.sqleditor';
+import 'pgadmin.tools.sqleditor';
 import pgWindow from 'sources/window';
 import _ from 'underscore';
 import Notify from '../../../../static/js/helpers/Notifier';
@@ -27,6 +26,7 @@ import { SchemaDiffSelect2Control, SchemaDiffHeaderView,
 
 import { handleDependencies, selectDependenciesForGroup,
   selectDependenciesForAll, selectDependencies } from './schema_diff_dependency';
+import { generateScript } from '../../../sqleditor/static/js/show_query_tool';
 
 var wcDocker = window.wcDocker;
 
@@ -252,6 +252,7 @@ export default class SchemaDiffUI {
           let data = res.data;
           let server_data = {};
           if (data) {
+            let sqlId = `schema${self.trans_id}`;
             server_data['sgid'] = data.gid;
             server_data['sid'] = data.sid;
             server_data['stype'] = data.type;
@@ -259,13 +260,13 @@ export default class SchemaDiffUI {
             server_data['user'] = data.user;
             server_data['did'] = self.model.get('target_did');
             server_data['database'] = data.database;
+            server_data['sql_id'] = sqlId;
 
             if (_.isUndefined(generated_script)) {
               generated_script = script_header + 'BEGIN;' + '\n' + self.model.get('diff_ddl') + '\n' + 'END;';
             }
-
-            pgWindow.pgAdmin.ddl_diff = generated_script;
-            generateScript(server_data, pgWindow.pgAdmin.DataGrid, Alertify);
+            localStorage.setItem(sqlId, generated_script);
+            generateScript(server_data, pgWindow.pgAdmin.Tools.SQLEditor, Alertify);
           }
 
           $('#diff_fetching_data').find('.schema-diff-busy-text').text('');
diff --git a/web/pgadmin/tools/search_objects/static/js/search_objects_dialog.js b/web/pgadmin/tools/search_objects/static/js/search_objects_dialog.js
index af8d0cfb3..44d0e0c3c 100644
--- a/web/pgadmin/tools/search_objects/static/js/search_objects_dialog.js
+++ b/web/pgadmin/tools/search_objects/static/js/search_objects_dialog.js
@@ -9,7 +9,7 @@
 
 import gettext from 'sources/gettext';
 import {Dialog} from 'sources/alertify/dialog';
-import {getPanelTitle} from 'tools/datagrid/static/js/datagrid_panel_title';
+import {getPanelTitle} from 'tools/sqleditor/static/js/sqleditor_title';
 import {retrieveAncestorOfTypeDatabase} from 'sources/tree/tree_utils';
 
 export default class SearchObjectsDialog extends Dialog {
